/* ad3.h -- OpenDWG Display definitions */

#ifndef AD3HINCLUDED
#define AD3HINCLUDED

#ifndef AD3TBLSTRUSDEFINED
#define AD3TBLSTRUSDEFINED
/*
  struct viewstru {
    char viewname[AD_MAX_STRLEN];
    double adviewdir[4];
    double adtarget[4];
    double adup[4];
    double ysize;
    OBJHANDLE objhandle;
  } ;
*/

  struct ltpstru {
    unsigned char   numltpvals;
    char   ltpname[AD_MAX_STRLEN];
    short  origltpno;
    struct adltpsegstru *segdata;
    unsigned short shpfileindex[15];
    double avgseglen;
    AD_OBJHANDLE objhandle;
    double patternlength;
    char ltypetextstr[256];
    char *lttptr[15];
  } ;

  struct blockstru {
    AD_BLKH blkinfo;
    OdaLong reserved;
    short origblkno;
    char vectorize;
  } ;

  struct shpstru {
    char *bigfontfile;
	char name[AD_MAX_STRLEN];
	char *file;
    char vertstyle;
    unsigned char flag;
    short origshpfileno;
    AD_OBJHANDLE objhandle;
    double widthfactor,oblique;
  } ;

  struct layerstru {
    char layname[AD_MAX_STRLEN];
    unsigned char layflag;
    short laycolor;
    unsigned short laylinetype,origlayno;
    ADVPMSK vpfrozflags;
    AD_OBJHANDLE objhandle;
  } ;

  struct mlstylestru {
    char  name[AD_MAX_STRLEN];
    unsigned short flag;
    unsigned short fillcolor;
    double startang,endang;
    unsigned char linesinstyle;
    AD_OBJHANDLE objhandle;
    short segcolor[16];
    short ltindex[16];
    double offset[16];
    short origmlsno;
  } ;
#endif

#ifndef STRUSDEFINED
#define STRUSDEFINED
typedef struct _rectlong       /* "Rectangle" structure type     */
 {OdaLong    Xmin;           /* minimum X                    */
  OdaLong    Ymin;           /* minimum Y                    */
  OdaLong    Xmax;           /* maximum X                    */
  OdaLong    Ymax;           /* maximum Y                    */
 }  rectlong;
typedef struct _polyHeadlong   /* Polygon "header" structure     */
 {short    polyBgn;        /* beginning index              */
  short    polyEnd;        /* ending index                 */
 }  polyHeadlong;
typedef struct _pointlong       /* "Point" structure type        */
 {OdaLong    XC;             /* X coordinate                  */
  OdaLong    YC;             /* Y coordinate                  */
 }  pointlong;

typedef struct _pointdouble
{
  double x;
  double y;
} pointdouble;
#endif

#define MODELSPACE 0
#define PAPERSPACE 1
#define NOCHANGE 0
#define LAYON       1
#define LAYOFF      2
#define LAYFREEZE   3
#define LAYFROZEN   3
#define LAYTHAW     4
#define LAYTHAWED   4

#define DLPON 1
#define DLPOFF 0

#define PIXELDATAIMGDATA 0x01000000L
#define PIXELDATANEWSEG  0x02000000L
#define PIXELDATANEWROW  0x03000000L

#ifndef ADVIEWPARMSTRUDEFINED
#define ADVIEWPARMSTRUDEFINED
typedef struct adviewparmstru {
  double viewdir[4];
  double target[4];
  double up[4];
  double xsize;
  double ysize;
} AD_VIEW_PARMS,*PAD_VIEW_PARMS;
#endif

#ifdef __cplusplus
extern "C" {
#endif

#ifndef AD3PARMSTRUDEFINED
#define AD3PARMSTRUDEFINED
struct ad3parmstru {
  short  colormap[256];
  double accuracy;
  short  vecfunclimit;
  short  keepvectorizing;
  unsigned short maxcirclesegs;  /* 0 for no limit */
  double aspectratio;
  short  dolinetypes;
} ;
#endif

extern struct ad3parmstru ad3parm;

typedef struct rascolstru {
  unsigned char red,grn,blu;
} AD_RASCOL,*PAD_RASCOL;

typedef struct pixelendstru {
  double edgept[2];
  double interppt[2];
  double interpdist;
  AD_RASCOL colors;
} AD_PIXSEG_DATA,*PAD_PIXSEG_DATA;


typedef struct olepicturedatastru
{
  AD_VMADDR blob;
  unsigned OdaLong blobsize;
  OdaLong pts[2][2];
  int numClipPts;
  pointlong *pClipPts;
} AD_OLE_PICTURE_DATA, *PAD_OLE_PICTURE_DATA;


typedef struct drawsegdatastru
{
  void    * cbptr;          /* type PAD_CB */
  double (*textmat)[4];
  double (*matlist)[4][4];
  void    * thisltp;        /* PAD_LTYPE   */
  void    * telcbptr;       /* PAD_CB      */
  struct vecwidthstru *vws;
  OdaLong    segltgroup;
  double  figuresize;
} AD_DRAWSEG_DATA, *PAD_DRAWSEG_DATA;

typedef struct acisviewdatastru
{
  AD_VMADDR       acisblob;
  AD_DRAWSEG_DATA DrawSeg;
  int   InterpolationQuality;
} AD_ACISVIEW_DATA, *PAD_ACISVIEW_DATA;


typedef struct rawimagedatastru
{
  pointlong pts[4];
  OdaLong numClipPts1;
  OdaLong numClipPts2;
  pointlong *pClipPts1;
  pointlong *pClipPts2;
  void *pUserData;

  /* Next 2 are for internal use only. */
  pointdouble *pPoints;
  int numPoints;
} AD_RAWIMAGE_DATA, *PAD_RAWIMAGE_DATA;


/* Structure passed to XrefOpenNotify function */
typedef struct
{
  AD_DB_HANDLE  drawingHandle;     /* Handle of drawing containing INSERT referencing
                                     this XREF */
  AD_OBJHANDLE  insertObjHandle;  /* INSERT entity objhandle */
} AD_XREFOPENNOTIFY_PARMS, *PAD_XREFOPENNOTIFY_PARMS;


#ifndef ADCDECL
#define ADCDECL
#endif

/* function prototypes */
void  ADCDECL adCloseAd3 _((void));
void  ADCDECL adCurrentPixelToWorld _((AD_DB_HANDLE handle,double *pixpt,double *pt0));
void  ADCDECL adCurrentWorldToPixel _((AD_DB_HANDLE handle,double *pt0,double *pixpt));
short ADCDECL adDrawDrawing _((AD_DB_HANDLE handle));
short ADCDECL adExtentsCalculated _((AD_DB_HANDLE handle));
void  ADCDECL adForceRegen _((AD_DB_HANDLE handle));
int   ADCDECL adGetDisplayProxiesAsAcis _((void));
short ADCDECL adInitAd3 _((void));
short ADCDECL adInitVectorize _((AD_DB_HANDLE handle,PAD_VIEW_PARMS adviewparms,rectlong *scrnrect,rectlong *dlrect,AD_OBJHANDLE psHandle));
short ADCDECL adMakeViewTransform _((AD_DB_HANDLE handle,PAD_VIEW_PARMS adviewparms,rectlong *scrnrect,rectlong *dlrect));
short ADCDECL adMinDlpRegenSizes _((AD_DB_HANDLE handle,double *minxsize,double *minysize));
void  ADCDECL adPanTarget _((PAD_VIEW_PARMS adviewparms,double deltax,double deltay));
void  ADCDECL adRawExtentsSizes _((AD_DB_HANDLE handle,double *xrawsize,double *yrawsize));
void  ADCDECL adRecalculateTextEntityPoint _((int recalculate));
short ADCDECL adRegenRequired _((AD_DB_HANDLE handle,PAD_VIEW_PARMS adviewparms));
void  ADCDECL adRotateCounterClockwise _((PAD_VIEW_PARMS adviewparms,double theta));
void  ADCDECL adRotateForward _((PAD_VIEW_PARMS adviewparms,double theta));
void  ADCDECL adRotateRight _((PAD_VIEW_PARMS adviewparms,double theta));
void  ADCDECL adSetAd3AcisViewFn _((int (*adAcisView)(PAD_ACISVIEW_DATA pAcisView, void *userdata)));
void  ADCDECL adSetAd3BadxrefFn _((void (*adBadxref)(char *xreffilename,void *userdata)));
void  ADCDECL adSetAd3BmpblobfromrasterFn _((void (*fnc)(char *fn, AD_VMADDR *bmpblob,void *userdata)));
void  ADCDECL adSetAd3ExamineentityFn _((void (*adExamineentity)(PAD_ENT_HDR adenhd, PAD_ENT aden,void *userdata)));
void  ADCDECL adSetAd3Examineentity2Fn _((void (*adExamineentity2)(PAD_ENT_HDR adenhd, PAD_ENT aden,short color, PAD_LTYPE ltp, ADPLOTSTYLE* style,void *userdata))); /* [ingr 94] */
void  ADCDECL adSetAd3ExaminertextFn _((void (*adExaminertext)(char *rtextfilename,char *newrtextfilename,void *userdata)));
void  ADCDECL adSetAd3ExaminexrefFn _((void (*adExaminexref)(char *xreffilename,char *newxreffilename,void *userdata)));
void  ADCDECL adSetAd3ExtractOlePicDataFn _((void (*adExtractOlePicData)(AD_VMADDR sourceblob, AD_VMADDR *destblob, void *userdata)));
void  ADCDECL adSetAd3LineToFn _((void (*LineTo)(OdaLong x,OdaLong y,void *userdata)));
void  ADCDECL adSetAd3MoveToFn _((void (*MoveTo)(OdaLong x,OdaLong y,void *userdata)));
void  ADCDECL adSetAd3OdometerFn _((void (*Odometer)(short color,void *userdata)));
void  ADCDECL adSetAd3PaintPolyFn _((void (*PaintPoly)(polyHeadlong *head,pointlong *pt,void *userdata)));
void  ADCDECL adSetAd3PolyPolygonFn _((void (*PolyPolygon)(pointlong *points, unsigned int* counts, unsigned int count, void *userdata)));
void  ADCDECL adSetAd3TristripFn _((void (*TristripFn)(pointlong *points, unsigned int count, void *userdata)));
void  ADCDECL adSetAd3PenColorFn _((void (*PenColor)(short color,void *userdata)));
void  ADCDECL adSetAd3PixelDataFn _((void (*PixelData)(char *data,short size,void *userdata)));
void  ADCDECL adSetAd3RawImageFn _((void (*RawImage)(PAD_RAWIMAGE_DATA rawimagedata, void *userdata)));
void  ADCDECL adSetAd3RawImagePrepareFn _((void (*RawImagePrepare)(char *file, void **ppImageData, void *userdata)));
void  ADCDECL adSetAd3RawImageReleaseFn _((void (*RawImageRelease)(void *pImageData, void *userdata)));
void  ADCDECL adSetAd3VectorFn _((void (*Vecfunc)(void *userdata)));
void  ADCDECL adSetAd3XrefhandleisFn _((void (*adXrefhandleis)(AD_DB_HANDLE handle,void *userdata)));
void  ADCDECL adSetAd3XrefcompleteFn _((void (*adXrefcomplete)(AD_DB_HANDLE handle,void *userdata)));
void  ADCDECL adSetAd3XrefopennotifyFn _((void (*adXrefopennotify)(char *fn, PAD_XREFOPENNOTIFY_PARMS pParms, void *userdata)));
void  ADCDECL adSetDisplayProxiesAsAcis _((int asAcis));
void  ADCDECL adSetDlpMode _((short mode));
void  ADCDECL adSetAd3OlePicDataFn _((void (*OlePicData)(PAD_OLE_PICTURE_DATA picdata,void *userdata)));
void  ADCDECL adSetAd3TtfStrokeFn _((int (*adTtfStroke)(unsigned short ch, double *starpt, PAD_TTF_DATA pTTF, PAD_TTF_STROKE_DATA pStroke, void *userdata)));
void  ADCDECL adSetViewParmsFromView _((AD_DB_HANDLE handle,PAD_VIEW_PARMS adviewparms,struct adviewstru *theview));
void  ADCDECL adTerminateVectorize _((AD_DB_HANDLE handle));
short ADCDECL adZoomExtents _((AD_DB_HANDLE handle,PAD_VIEW_PARMS adviewparms));
void  ADCDECL adZoomVsMax _((AD_DB_HANDLE handle,PAD_VIEW_PARMS adviewparms));
void  ADCDECL adSetAd3ExamineplotstyletblFn _((void (*adExamineplotstyletbl)(char *filename,char *newfilename,void *userdata))); /* [ingr 94] */
void  ADCDECL adSetAd3LineweightFn _((void (*Lineweight)(OdaLong weight, void *userdata))); /* [ingr 94] */
void  ADCDECL adSetDefaultLineweight _((int lwdefault)); /* [ingr 94] */
short ADCDECL adGetActiveLayout _((AD_DB_HANDLE handle));
short ADCDECL adLoadPlotStyles _((AD_DB_HANDLE handle));
short ADCDECL adGetLinewidthFromWeight _((AD_DB_HANDLE handle, short weight, double *width));
double ADCDECL adGetScaledLinewidthFromWeight _((AD_DB_HANDLE handle, short weight));
void  ADCDECL adSetModelSpaceLineweightScale _((double scale));
void  ADCDECL adSetPixelLineweightScale _((double scale));
AD_DB_HANDLE  ADCDECL adCurrentDbHandle _(());


/* Interpolation quality is the number of segments drawn on PI/2 arc
   and/or between 2 spline control points */
void  ADCDECL adSetClipBoundaryQuality _((int value));
int   ADCDECL adGetClipBoundaryQuality _(());

void  ADCDECL adSetInterpolationQuality _((int value));
int   ADCDECL adGetInterpolationQuality _(());

/* Break Mtext lines between characters with no spaces, as Japanese NT does. */
void ADCDECL adUseJapaneseStyleMTextBreaks _((int value));

const double * ADCDECL adGetWorldToPixelMatrix _((AD_DB_HANDLE handle));
void ADCDECL adSplitPolyPolygon _((pointlong *points, unsigned int* counts, unsigned int count, void * userdata));

/* Causes ODV to send back original lineweight values, rather than scaled lineweights. */
void ADCDECL adUseOriginalLineweights _((int useOriginal));

#ifdef __cplusplus
}
#endif


#endif

