/***************************************************************************
                          helpabout.cpp
                             -------------------
    begin                : Sat May 12 2001
    copyright            : (C) 2001 by Andrew Bibb
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, version 2 of the License, or any later  * 
 *   version.                                                              *
 *                                                                         *
 ***************************************************************************/

//	functions to display the Help manual are here

#include "helpabout.h"

//	Constructor for the HelpWindow class.
HelpWindow::HelpWindow(QWidget* parent, const char* name)
						: QTextBrowser(parent,name)
{
 	pathtomanfiles = QString();

	//	try to find the location of help manual
	QFileInfo fi = QFileInfo();	
	unsigned int i = 0;
	QString indexfile = "/index.html";
	QString searcharray[]= {QString(PathToExec() + "/docs"),
													QString(PathToExec() + "/docs/en"),
													"/usr/local/doc/viewer",
												 	"/usr/local/doc/lx-viewer",
													"/usr/local/doc/lx_viewer",
													"/usr/local/doc/lxviewer",
												 	"/usr/doc/viewer",
												 	"/usr/doc/lx-viewer",
													"/usr/doc/lx_viewer",
													"/usr/doc/lxviewer",
													"/usr/share/doc/viewer",
													"/usr/share/doc/lx-viewer",
													"/usr/share/doc/lx_viewer",
													"/usr/share/doc/lxviewer"
													};
  do
	{
		fi.setFile(searcharray[i++] + indexfile);
	} while (!fi.exists() && i < sizeof searcharray / sizeof searcharray[0]);

	if (fi.exists())
	{
		pathtomanfiles = searcharray[i-1];
		mimeSourceFactory()->setFilePath(fi.filePath());
		setSource(fi.filePath());
	}
	else
	{
		QString nohelpfound;
		nohelpfound.append(tr("<h1><center>No Manual Pages Were Found</center></h1>"));
		nohelpfound.append(tr("<h3>The manual pages must be located in one of the following locations:</h3>"));
		for (unsigned int i = 0; i < sizeof searcharray / sizeof searcharray[0]; i++)
			nohelpfound.append(tr("<p>" + searcharray[i]));
		setText(nohelpfound);
	}	

	setFrameStyle(QFrame::Panel | QFrame::Sunken);
	resize(640,700);
	setCaption(tr("LX_Viewer Manual"));
}


//	function to return the path containing the help files.  If none can be
//	found return a null string
QString HelpWindow::getPath(){return pathtomanfiles;}
