##  We are need the qt libraries, we want compiler warnings on, and this is a release version of the program  
CONFIG += qt warn_on release

##  Set the installation location.  This can be modified if you wish
INSTALL_DEST = /usr/local/lx-viewer

##  List of header files in the program
HEADERS +=3Dview.h
HEADERS +=ad2.h
HEADERS +=ad3.h
HEADERS +=colorfunctions.h
HEADERS +=commandproc.h
HEADERS +=drawingboard.h
HEADERS +=drawingenvironment.h
HEADERS +=errorhandlers.h
HEADERS +=fileio.h
HEADERS +=helpabout.h
HEADERS +=infomessage.h
HEADERS +=layermanager.h
HEADERS +=OD_interface.h
HEADERS +=odio.h
HEADERS +=plotter.h
HEADERS +=report.h
HEADERS +=resource.h
HEADERS +=serialport.h
HEADERS +=splashapp.h
HEADERS +=svgexport.h
HEADERS +=utilities.h
HEADERS +=vectorize.h

##  List of source files in the program
SOURCES +=3Dview.cpp
SOURCES +=colorfunctions.cpp
SOURCES +=commandproc.cpp
SOURCES +=drawingboard.cpp
SOURCES +=drawingenvironment.cpp
SOURCES +=errorhandlers.cpp
SOURCES +=fileio.cpp
SOURCES +=helpabout.cpp
SOURCES +=infomessage.cpp
SOURCES +=layermanager.cpp
SOURCES +=main.cpp
SOURCES +=OD_interface.cpp
SOURCES +=plotter.cpp
SOURCES +=report.cpp
SOURCES +=serialport.cpp
SOURCES +=splashapp.cpp
SOURCES +=svgexport.cpp
SOURCES +=utilities.cpp
SOURCES +=vectorize.cpp

## The OpenDWG compiled library files are linked as object files
OBJECTS += OpenDWG/ad2.a
OBJECTS += OpenDWG/ad3.a

##  Place all object files in their own directory and moc files in their own directory
##  This is not necessary but keeps things cleaner.
OBJECTS_DIR = ./object_files
MOC_DIR = ./moc_files

##  Name of application and destination.  If you want to change the installation destination do it at the top
##  of the file, not here.
TARGET = lxv
DESTDIR = $$INSTALL_DEST

##  Install the documentation
documentation.path = $$INSTALL_DEST/docs
documentation.files += ./docs/en/*
INSTALLS += documentation

## Install the adinit.dat support file
support.path = $$INSTALL_DEST/opendwg
support.files += ./OpenDWG/adinit.dat
INSTALLS += support

## Install the graphics files - note use .extra here because for some reason qmake wants to add
## a strip command after all xpm or png iles and this gives an error message when run.  
graphic.path = $$INSTALL_DEST/graphics
INSTALLS += graphic
graphic.extra += cp ./graphics/*.* $$INSTALL_DEST/graphics/


