/***************************************************************************
                          resource.h
                             -------------------
    begin                : Wed Apr 18 2001
    copyright            : (C) 2001 by Andrew Bibb
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, version 2 of the License, or any later  *
 *   version.                                                              *
 *                                                                         *
 ***************************************************************************/

///////////////////////////////////////////////////////////////////
// resource.h  -- contains macros used for commands





#ifndef RESOURCE_H
#define RESOURCE_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

///////////////////////////////////////////////////////////////////
//	VERSION CONTROL
#define LX_VERSION			"1.0.3 -- Modifications for OD 2.012 libraries 20 March 2005"

///////////////////////////////////////////////////////////////////

#define QT_PNG	-3
//#define QT_XPM	-2	//	removed in 0.97
#define QT_BMP	-1
//#define AD_DWG	 0	//	defined in ad2.h
//#define AD_DXF	 1  //	defined in ad2.h
//#define AD_BDXF	 2  //	defined in ad2.h
#define LX_SVG	11

////////////////////////////////////////////////////////////////////
//	SUPPORT FILE LOCATION
////////////////////////////////////////////////////////////////////	
#define LXV_HOME				"/lx-viewer"
#define LXV_FONT				"/fonts"
#define LXV_PCP					"/pcp"

///////////////////////////////////////////////////////////////////
// COMMAND VALUES FOR MENUBAR AND TOOLBAR ENTRIES
///////////////////////////////////////////////////////////////////

// File-menu entries
//#define ID_FILE_NEW
#define ID_FILE_OPEN                10100
#define ID_FILE_CLOSE								10200
#define ID_FILE_SAVE                10300
#define ID_FILE_SAVE_AS    					10400
#define ID_FILE_AUDIT								10500
#define ID_FILE_REPORT							10600
#define ID_FILE_PRINT								10700
#define ID_FILE_BATCH_CONVERT				10800
#define ID_FILE_BATCH_PLOT					10900
#define ID_FILE_QUIT                11000

///////////////////////////////////////////////////////////////////
// View-menu entries
#define	ID_VIEW_REDRAW							20100
#define ID_VIEW_REGEN								20200
#define ID_VIEW_PAN									20300
	#define ID_VIEW_PAN_POINT					20301
	#define ID_VIEW_PAN_UP						20302
	#define ID_VIEW_PAN_RIGHT					20303
	#define ID_VIEW_PAN_DOWN					20304
	#define ID_VIEW_PAN_LEFT					20305
#define ID_VIEW_ZOOM								20400
	#define ID_VIEW_ZOOM_IN						20401
	#define ID_VIEW_ZOOM_OUT					20402
	#define ID_VIEW_ZOOM_WINDOW				20403
	#define ID_VIEW_ZOOM_EXTENTS			20404
	#define ID_VIEW_ZOOM_PREVIOUS			20405
	#define ID_VIEW_ZOOM_VIEWMAX			20406
	#define ID_VIEW_ZOOM_CENTER				20407
#define ID_VIEW_3DVIEW							20500
#define ID_VIEW_PREDEFINED_VIEW			20600
	#define ID_VIEW_TOP								20601
  #define ID_VIEW_FRONT							20602
	#define ID_VIEW_RIGHT_SIDE				20603
	#define ID_VIEW_LEFT_SIDE					20604
	#define ID_VIEW_BACK							20605
	#define ID_VIEW_BOTTOM						20606
	#define ID_VIEW_AERIAL_RFRONT			20607

	#define ID_VIEW_AERIAL_LFRONT			20608
	#define ID_VIEW_AERIAL_RREAR			20609
	#define ID_VIEW_AERIAL_LREAR			20610
	#define ID_VIEW_BELOW_RFRONT			20611
	#define ID_VIEW_BELOW_LFRONT			20612
	#define ID_VIEW_BELOW_RREAR				20613
	#define ID_VIEW_BELOW_LREAR				20614
#define ID_VIEW_WCSPLANVIEW					20700

///////////////////////////////////////////////////////////////////
// Tool-menu entries

#define ID_TOOL_TEXTWINDOW					30100
#define ID_TOOL_STATUSBAR           30200
#define ID_TOOL_CMDBAR							30300
#define ID_TOOL_TOOLBAR_FILE				30400
#define ID_TOOL_TOOLBAR_VIEW				30500
#define ID_TOOL_TOOLBAR_LAYER				30600
#define ID_TOOL_TOOLBAR_HELP				30700
#define ID_TOOL_TOOLBUTTON_SIZE			30800
#define ID_TOOL_TOOLTIP_ENABLE			30900
#define ID_TOOL_BACKGROUND_COLOR		31000

///////////////////////////////////////////////////////////////////
//	Settings menu entries
#define ID_SETTINGS_LAYERDIAG				40100
#define ID_SETTINGS_ALIASDIAG				40200

///////////////////////////////////////////////////////////////////
// Help-menu entries
#define ID_HELP_MAN									50100
#define ID_HELP_ABOUT_LX						50200
#define	ID_HELP_ABOUT_QT						50300
#define ID_HELP_ABOUT_OD						50400

///////////////////////////////////////////////////////////////////
// General application values

#define NORUBBERBAND	0
#define RUBBERLINE		1
#define	RUBBERBOX			2

#define COPY			1
#define XOR				2

//	this group is to determine where status messages are displayed
//	values are added together bitwise
#define	SBAR				static_cast<unsigned char>(1)		//	status bar
#define TWIN				static_cast<unsigned char>(2)   //	text window
#define CWIN				static_cast<unsigned char>(4)		//	command window
#define SBAR_TWIN		static_cast<unsigned char>(3)
#define SBAR_CWIN		static_cast<unsigned char>(5)
#define TWIN_CWIN		static_cast<unsigned char>(6)
#define DISP_ALL		static_cast<unsigned char>(7)		

//	these are used as keys in infomessage.cpp.  All numbers here should be
//	less than 10000 so that they do not conflict with the ID_ numbers above
//	which are used in the same function.  Have message numbers be up to 4999
//	and command calls 5000 to 9999
#define CUSTOM_MESSAGE								-1
#define LX_CANCEL											1
#define CAPTION_INFORMATION					 	10
#define CAPTION_WARNING								20
#define CAPTION_ABOUT									30
#define CAPTION_INITIALIZE						40
#define END_APP_QUESTION							50
#define FILE_DOES_NOT_EXIST						100
#define NO_READ_PERMISSION						110
#define NO_WRITE_PERMISSION						120
#define NO_DRAWING_LOADED_3D					200
#define NO_DRAWING_LOADED_PRINT				210
#define NO_DRAWING_LOADED_CMD_LINE		220
#define CANNOT_SET_CURRENT_TO_FROZEN	300
#define	VECTORIZE_ERROR								400
#define CANNOT_INITIALIZE_AD3					500
#define NO_PS_VIEWPORTS								600
#define CALL_HELP											800
#define CALL_VERSION									810
#define COMMAND_LIST									820
#define COMMAND_LINE_LIST							830
#define TILE_MODE											5010

//	used to define what type of color dialog is constructed
#define COLOR_DIAG_FOR_PLOTTER				10
#define COLOR_DIAG_FOR_LAYER					20
#define COLOR_DIAG_FOR_ENTITY					30

///////////////////////////////////////////////////////////////////
// Hot Key equivalances

#define HELP					Key_F1	//	Help  Key
#define TEXTWINDOW		Key_F2	//	Text Window
#define CMDBAR				Key_F3	//	Command Bar
#define VIEWDIALOG		Key_F5	//	3D Dialog box
#define STATUSBAR	  	Key_F10	// 	Status bar

/*	keys commented out below moved to drawingboard.cpp for
		translation purposes
#define FILE_OPEN			CTRL+Key_O	//	File Open
#define FILE_SAVE			CTRL+Key_S	//	File Save
#define REPORT				CTRL+Key_R	//	Report on drawing contents
#define PLOT					CTRL+Key_P	//	Plot drawing
#define QUIT					CTRL+Key_Q	//	Quit
*/

#define ZOOM_IN				CTRL+UNICODE_ACCEL + '+'	//	Zoom In
#define ZOOM_OUT			CTRL+UNICODE_ACCEL + '-'	//	Zoom Out	
#define ZOOM_PREVIOUS	CTRL+UNICODE_ACCEL + '0'	//	Zoom Previous

#define TOP_VIEW				CTRL+Key_5	//	Top (Plan) view
#define FRONT_VIEW			CTRL+Key_2	//	Front View
#define RIGHT_SIDE			CTRL+Key_6	//	Right Side view
#define	LEFT_SIDE				CTRL+Key_4	//	Left Side view
#define BACK_VIEW				CTRL+Key_8	//	Back View
#define AERIAL_RFRONT		CTRL+Key_3	//	Above and from the right front
#define AERIAL_LFRONT		CTRL+Key_1	//	Above and from the left front
#define AERIAL_RREAR		CTRL+Key_9	//	Above and from the right rear
#define AERIAL_LREAR		CTRL+Key_7	//	Above and from the left rear

// pi
#include <math.h>
#ifndef M_PI
#define M_PI                  3.1415926535897932384626433832795
#endif

#endif // RESOURCE_H
