/***************************************************************************
                          serialport.cpp  -  description
                             -------------------
    begin                : Sun Feb 24 2002
    copyright            : (C) 2002 by Andrew Bibb
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, version 2 of the License, or any later  * 
 *   version.                                                              *
 *                                                                         *
 ***************************************************************************/

//	routines to manage output to a serial port
//	for HPGL output

#include "serialport.h"
#ifndef _WIN32
#include <unistd.h>
#include <fcntl.h>
#include <string.h>	//	added because one user reported his compiler complained that
										//	it was missing.  I have no idea why.

//	routine to open the serial port for reading and writing
//	returns the open device, or -1 on error
int openPort()
{
	int rtnval;
	int flags = O_RDWR | O_NONBLOCK;
	rtnval = open("/dev/ttyS1", flags);
	return rtnval != -1 ? rtnval : -1;
}
	
//	routine to write data to the serial port
void writeToPort(int fd,char* buff)
{
	int numbytes;
	numbytes = strlen(buff);
	write(fd,buff,numbytes);
}

//	routine to close the serial port
int closePort(int fd)
{
	int rtnval;
	rtnval = close(fd);
	return rtnval > 0 ? rtnval : 0;
}

#else

// dummy implementations for Windows

int openPort()
{
	return -1;
}
	
//	routine to write data to the serial port
void writeToPort(int fd, char* buff)
{
}

//	routine to close the serial port
int closePort(int fd)
{
	return 0;
}

#endif
