/***************************************************************************
                          splashapp.cpp  -  splash screen
                             -------------------
    begin                : Mon Sep 9 2002
    copyright            : (C) 2002 by Andrew Bibb
    email                : buyer242299@aol.com
    source               : http://lx-viewer.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, version 2 of the License, or any later  *
 *   version.                                                              *
 *                                                                         *
 ***************************************************************************/

//   This is a custom qApplication class that supports a splash screen
//   It is modeled very heavily on the similar class in QT-Designer

#include "splashapp.h"
#include "utilities.h"

#include <qfile.h>   // an IO device that opperates on files
#include <qdir.h>    // access to directory structures and files
#include <qlabel.h>  // provides a text or image display
#include <qpixmap.h> // off-screen pixel based paint device


static QLabel* splash = 0;

//   constructor for the class
SplashApplication::SplashApplication(int& argc, char **argv):QApplication(argc,argv){}

//   showsplash member function
QLabel* SplashApplication::showSplash()
{
    QRect screen = QApplication::desktop()->screenGeometry();
    splash = new QLabel(0,"splash",
                        WDestructiveClose   |
                        WStyle_Customize   |
                        WStyle_NoBorder      |
                        WX11BypassWM         |
                        WStyle_StaysOnTop   );
    splash->setFrameStyle(QFrame::WinPanel | QFrame::Raised);

    QFile f;
    f.setName(PathToExec() + QString("/graphics/splash.png"));
    if (f.exists())
    {
        QPixmap p = QPixmap(f.name());
        splash->setPixmap(p);
        splash->adjustSize();
        splash->move(screen.center()-QPoint(splash->width()/2, splash->height()/2));
        splash->show();
        splash->repaint(FALSE);
        QApplication::flush();
    }

    return splash;
}

void SplashApplication::closeSplash()
{
   splash->hide();
}

