/***************************************************************************
                          svgexport.h  -  description
                             -------------------
    begin                : Sat Nov 23 2002
    copyright            : (C) 2002 by Andrew Bibb
    email                : buyer242299@aol.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, version 2 of the License, or any later  *
 *   version.                                                              *
 *                                                                         *
 ***************************************************************************/


/*	Header file for Scalable Vector Graphics (a subset of XML) output*/

#ifndef SVGEXPORT_H
#define SVGEXPORT_H

//	QT includes
#include <qtextstream.h>
#include <qstring.h>
#include <qfile.h>
#include <qdatetime.h>
#include <qcolor.h>
#include <qpointarray.h>

class svgExport : public QFile
{
	public:
		svgExport(const QString name);	//	constructor
		bool startWrite();
		bool endWrite();
		void createRoot(long w = 1,long h = 1);
		
		void moveTo(const long& ,const long&);
		void lineTo(const long& ,const long&);
		void setColor(const QColor&);
		void paintPoly(const QPointArray&);

	private:
		//	members
		QTextStream os;		//	text stream to operate on this
		long startx;			//	x value of previous point
		long starty;			//	y value of previous point
		int ptcntr;				//	counter of the number of points in a list
		QString	s_red;		//	red component in color
		QString s_green;	//	green component in color
		QString s_blue;		//	blue component in color
		short	linewidth;	//	linewidth for svg
		bool rootopen;		//	is the root element (svg) open
		bool grpopen;			//	is a group element open
		QString rootelem;	//	string containing the root element	
		QString curpath;	//	string containing the current path attributes
		
    //	data - more or less constant values
		QString content;	//	header text
		QString pub_id;		//	public identifer for svg
		QString sys_id;		//	system identifer for svg
		QString nspace;		//	XML svg namespace	
		int nline_at;			//	create a new line in point data at
	
};

#endif

