/***************************************************************************
                          vectorize.h
                             -------------------
    begin                : Sun Apr 22 2001
    copyright            : (C) 2001 by Andrew Bibb
    source               : http://lx-viewer.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, version 2 of the License, or any later  *
 *   version.                                                              *
 *                                                                         *
 ***************************************************************************/

// Routines to vectorize and display the drawing.  Includes support for the view menu entries
#ifndef VECTORIZE_H
#define VECTORIZE_H

// Qt includes
#include <qptrstack.h>
#include <qpoint.h>
#include <qpointarray.h>

// Functions
void	initializegraphics(void);			// function to initialize graphics area				
void	initializeplotarea(void);			// function to initialize the plotting area			
void 	setcontrolvariables(void);			// function to set the ad3 control variables			
void	vectorize (AD_DB_HANDLE,AD_OBJHANDLE);		// function to vectorize the drawing				
void	resizewindow(AD_DB_HANDLE,AD_OBJHANDLE,short);	// function called by db custom resize event handler		
void	newsizes(QPoint,QPoint);			// function to compute new x & y size at proper aspect ratio	
void 	plotps(AD_DB_HANDLE,AD_OBJHANDLE);		// function to plot the drawing - postscript output		
void	plothpgl(AD_DB_HANDLE,AD_OBJHANDLE);		// function to plot the drawing - hpgl ouput			
void 	updateViewStructure(AD_DB_HANDLE dh);		// function to keep dwgheader and adviewparms in sync		
// View menu functions
void	LX_Redraw(AD_DB_HANDLE);								// function to redraw the screen 				
void	LX_Regen(AD_DB_HANDLE);									// function to regenerate the drawing 			
void	LX_Pan(AD_DB_HANDLE, QPoint anchorpoint = QPoint(-1,-1));	// function to pan the drawing 				
void 	LX_PanOrtho(AD_DB_HANDLE,float,float);		// function to pan the drawing up, right, down,left
void	LX_ZoomIn(AD_DB_HANDLE,float);					// function to zoom in to the drawing	 		
void	LX_ZoomOut(AD_DB_HANDLE,float);					// function to zoom the drawing out 			
void	LX_ZoomWindow(AD_DB_HANDLE);						// function to zoom window 				
void	LX_ZoomExtents(AD_DB_HANDLE);						// function to zoom extents 				
void	LX_ZoomPrevious(AD_DB_HANDLE);					// function to zoom previous		 		
void	LX_ZoomViewmax(AD_DB_HANDLE);						// function to zoom out to max of the display list 	
void	LX_ZoomCenter(AD_DB_HANDLE);						// function to zoom center 				
void 	LX_3DView(AD_DB_HANDLE);								// function to call the 3D view dialos 			
void	LX_PredefinedView(AD_DB_HANDLE, short);	// function to zoom to a predefined view 		

#endif


